libstdc++: __gnu_parallel::_LoserTree< false, _Tp, _Compare > Class Template Reference

libstdc++

__gnu_parallel::_LoserTree< false, _Tp, _Compare > Class Template Reference

`#include <losertree.h>`

Inheritance diagram for __gnu_parallel::_LoserTree< false, _Tp, _Compare >:
[legend]

## Public Member Functions
| _LoserTree (unsigned int __k, _Compare __comp)
void | __delete_min_insert (_Tp __key, bool __sup)
int | __get_min_source ()
void | __init ()
unsigned int | __init_winner (unsigned int __root)
void | __insert_start (const _Tp &__key, int __source, bool __sup)

## Protected Attributes
unsigned int | _M_ik
unsigned int | _M_log_k
unsigned int | _M_offset

## Detailed Description

template<typename _Tp, typename _Compare>
class __gnu_parallel::_LoserTree< false, _Tp, _Compare >

Unstable _LoserTree variant.

Stability (non-stable here) is selected with partial specialization.

Definition at line 261 of file losertree.h.

## Constructor & Destructor Documentation

## ◆ _LoserTree()

template<typename _Tp, typename _Compare>

__gnu_parallel::_LoserTree< false, _Tp, _Compare >::_LoserTree | ( | unsigned int | __k,
|  | _Compare | __comp )
| inline

Definition at line 272 of file losertree.h.

## Member Function Documentation

## ◆ __delete_min_insert()

template<typename _Tp, typename _Compare>

void __gnu_parallel::_LoserTree< false, _Tp, _Compare >::__delete_min_insert | ( | _Tp | __key,
|  | bool | __sup )
| inline

Delete the _M_key smallest element and insert the element __key instead.

Parameters

  __key | the _M_key to insert
  __sup | true iff __key is an explicitly marked supremum

Definition at line 324 of file losertree.h.

## ◆ __get_min_source()

int __gnu_parallel::_LoserTreeBase< _Tp, _Compare >::__get_min_source | ( |  | ) |
| inline

Returns
  the index of the sequence with the smallest element.

Definition at line 155 of file losertree.h.

## ◆ __init()

template<typename _Tp, typename _Compare>

void __gnu_parallel::_LoserTree< false, _Tp, _Compare >::__init | ( |  | ) |
| inline

Definition at line 311 of file losertree.h.

## ◆ __init_winner()

template<typename _Tp, typename _Compare>

unsigned int __gnu_parallel::_LoserTree< false, _Tp, _Compare >::__init_winner | ( | unsigned int | __root | ) |
| inline

Computes the winner of the competition at position "__root".

Called recursively (starting at 0) to build the initial tree.

Parameters

  __root | __index of the "game" to start.

Definition at line 284 of file losertree.h.

References __init_winner().

Referenced by __init_winner().

## ◆ __insert_start()

void __gnu_parallel::_LoserTreeBase< _Tp, _Compare >::__insert_start | ( | const _Tp & | __key,
|  | int | __source,
|  | bool | __sup )
| inline

Initializes the sequence "_M_source" with the element "__key".

Parameters

  __key | the element to insert
  __source | __index of the __source __sequence
  __sup | flag that determines whether the value to insert is an explicit __supremum.

Definition at line 134 of file losertree.h.

## Member Data Documentation

## ◆ _M_ik

unsigned int __gnu_parallel::_LoserTreeBase< _Tp, _Compare >::_M_ik
| protected

Definition at line 69 of file losertree.h.

## ◆ _M_log_k

unsigned int __gnu_parallel::_LoserTreeBase< _Tp, _Compare >::_M_log_k
| protected

log_2{_M_k}

Definition at line 72 of file losertree.h.

## ◆ _M_offset

unsigned int __gnu_parallel::_LoserTreeBase< _Tp, _Compare >::_M_offset
| protected

Definition at line 69 of file losertree.h.

The documentation for this class was generated from the following file:

- losertree.h